#cs ----------------------------------------------------------------------------

 AutoIt Version : 3.3.8.1
 Auteur:	Jrmy

 Fonction du Script :
	Fonction qui autorise un script  ne se lancer qu'un certain nombre de fois par session.

#ce ----------------------------------------------------------------------------

; $pMaxLimite => Nombre d'utilisation(s) maximum autoris par session.
; $pBoolExcluSysteme => Supprime la limitation pour le compte systme.
Func ExecutionAutorisee ($pMaxLimite, $pBoolExcluSysteme = True)
	If Not IsInt ($pMaxLimite) Then Return SetError (1, 0, -1)
	If Not $pMaxLimite > 0 Then Return SetError (2, 0, -1)
	If Not IsBool ($pBoolExcluSysteme) Then Return SetError (3, 0, -1)
	; On vrifie s'il s'agit du compte systme et s'il est exclus de la limitation.
	If $pBoolExcluSysteme And UtilisateurEstLeSysteme () Then Return True
	Local $objWMI = ObjGet ("winmgmts:\\.\root\cimv2")
	; On rcupre les informations sur le script actuel.
	Local $colResults = $objWMI.ExecQuery ("Select * from Win32_Process WHERE Name = '" & @ScriptName & "'")
	; On compte le nombre de lancement simultans du programme sur la session.
	Local $nbLancements = 0
	Local $compte = ""
	Local $domaine = ""
	; Pour chaque objet trouv.
	For $objItem in $colResults
		; Si le propritaire de l'objet est l'utilisateur actuel.
		If $objItem.GetOwner ($compte, $domaine) = 0 Then; On augmente le nombre de lancement simultans.
			If ($compte = @UserName) And ($domaine = @LogonDomain) Then
				$nbLancements += 1
				; Si la limite est dpasse on retourne faux.
				If $nbLancements > $pMaxLimite Then Return False
			EndIf
		EndIf
	Next
	; La limite n'est pas dpasse, on retourne vrai.
	Return True
EndFunc

; Fonction qui dtermine si l'utilisateur est le systme.
Func UtilisateurEstLeSysteme ()
	; On vrifie toutes les possibilits d'criture du systme.
	Switch @UserName
		Case "Systme", "systme", "SYSTME", "Systeme", "systeme", "SYSTEME", "System", "system", "SYSTEM"
			Return True
		Case Else
			If ((StringLower (@UserName) = "systme") Or (StringLower (@UserName) = "system") Or (StringLower (@UserName) = "systeme")) Then Return True
			Return False
	EndSwitch
EndFunc