#NoTrayIcon
#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=img\Inactif.ico
#AutoIt3Wrapper_Compile_Both=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <Processes_Threads_nDLLs\_GetDebugPrivilegeRtl.au3>
#include <Processes_Threads_nDLLs\_ProcessFunctions.au3>
#include <Array.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <StaticConstants.au3>
#include <GuiListView.au3>
#include "C:\Scripts\Forum\@Fonctions\ExecutionAutorisee.au3"

#cs ----------------------------------------------------------------------------

	AutoIt Version : 3.3.8.1
	Auteur: Jrmy

	Fonction du Script :
	Vrifie et affiche les logiciels qui ne sont pas connects sur le serveur.

#ce ----------------------------------------------------------------------------

; Version du programme :
Global $numVersion = "4.0.1"

; Une fois compil, on peut vrifier que le script ne s'excute qu'une seule fois.
If Not ExecutionAutorisee (1) Then
	MsgBox (16, "Script en cours", "Le script est dj lanc sur cette session.", 20)
	Exit ; On quitte l'application
EndIf

#Region ### Variables #########
; Dossier contenant les installations.
Global $dossier = @ProgramFilesDir

; Titre de la fentre principale.
Global $titre = "Activit des logiciels - " & $numVersion

Opt ("GUIOnEventMode", 1)

; Dclaration des deux fentres.
Global $fenetrePrincipale

; Boolen pour indiquer si l'on est en mode dtaill ou en mode simple.
Global $modeDetaille = False

; Tableau des logiciels installs sur le serveur.
Global $tabLogiciel [1] = [0]
; Tableau contenant les chemins actifs.
Global $tabChemin [1] [2] = [[0, 1]]
; Tableau des index de processus Systme. Contient les index du tableau des logiciels inactifs dont les processus appartiennent au Systme.
Global $tabProcessSystem [1] = [""]
; Tableau contenant les anciens index de processus Systme.
Global $tabAncienProcessSystem [1] = [""]
; Tableau  afficher, contient les logiciels inactifs.
Global $tabLogicielsInactifs [1] [2] = [[0, 0]]
Global $tabAncienLogicielsInactifs [1] [2] = [[0, 0]]

; Tableau contenant les logiciels actifs.
Global $tabLogicielActifs [1] [2] = [[0, 0]]
Global $tabAncienLogiclielsActifs [1] [2] = [[0, 0]]

; Largeur de la fentre en fonction du mode choisi.
Global Const $widthSimple = 578
Global Const $widthDetaille = 477

; Largeur par dfaut de la fentre principale.
Global $iWidth = $widthSimple

; Obsolte mais conserv car pourrait tre rutilis ultrieurement.
; Boolen qui indique si le changement est d  un arrt de service.
Global $arretService = False
#EndRegion ### Fin : Variables #########

Main ()

#Region ### Fonction principale #########
Func Main ()
	_GetDebugPrivilegeRtl ()
	Analyse_Dossier ($dossier)
	Analyse_Generale (True)
	Affiche_Tableau ($titre)
	$tabAncienLogicielsInactifs = $tabLogicielsInactifs
	$tabAncienLogiclielsActifs = $tabLogicielActifs
	WinActivate ($fenetrePrincipale)
	Verifie_Processus ()
EndFunc
#EndRegion ### Fin : Fonction principale #########

#Region ### Actualiser #########
; Actualise l'affichage de la fentre principale.
Func Actualiser ()
	ReDim $tabLogiciel [1]
	$tabLogiciel [0] = 0
	Analyse_Dossier ($dossier)
	Analyse_Generale ()
	Compare_Resultat ($tabLogicielActifs, $tabAncienLogiclielsActifs, False)
	Compare_Resultat ($tabLogicielsInactifs, $tabAncienLogicielsInactifs)
	MAJ_Affichage ()
	Local $tItemLimit = $tabLogicielsInactifs [0] [0]
	If $tabLogicielActifs [0] [0] > $tabLogicielsInactifs [0] [0] Then $tItemLimit = $tabLogicielActifs [0] [0]
	Ajuste_Affichage ($tItemLimit)
	$tabAncienLogicielsInactifs = $tabLogicielsInactifs
	$tabAncienLogiclielsActifs = $tabLogicielActifs
EndFunc
#EndRegion ### Fin : Actualiser #########

#Region ### Affiche_Tableau #########
; Affiche la fentre principale.
Func Affiche_Tableau ($pTitle)

	Local $tItemLimit = $tabLogicielsInactifs [0] [0]
	If $tabLogicielActifs [0] [0] > $tabLogicielsInactifs [0] [0] Then $tItemLimit = $tabLogicielActifs [0] [0]

	; Ajuste la hauteur de la fentre.
	$iHeight = Hauteur ($tItemLimit)

	; Cration de l'interface graphique.
	$fenetrePrincipale = GUICreate ($pTitle, $iWidth, $iHeight, -1, -1, BitOR ($WS_SIZEBOX, $WS_MINIMIZEBOX))
	GUISetOnEvent ($GUI_EVENT_CLOSE, "Quitter")
	GUISetOnEvent ($GUI_EVENT_MINIMIZE, "Reduire")
	GUISetOnEvent ($GUI_EVENT_RESTORE, "Restaurer")

	; On rcupre les informations sur la taille de la fentre.
	Local $aiGUISize = WinGetClientSize ($fenetrePrincipale)

	; Cration de la liste occupant toute la fentre.
	Global $hListViewSimple1 = GUICtrlCreateListView ("", 0, 0, $aiGUISize [0]/2, $aiGUISize [1] - 20)
	Global $hListViewSimple2 = GUICtrlCreateListView ("", $aiGUISize [0]/2, 0, $aiGUISize [0]/2, $aiGUISize [1] - 20)
	Global $hListViewDetaille = GUICtrlCreateListView ("", 0, 0, $aiGUISize [0], $aiGUISize [1] - 20)

	GUICtrlSetState ($hListViewDetaille, $GUI_HIDE)

	; On ajoute les colonnes  la liste. Avec le texte centr.
	_GUICtrlListView_InsertColumn ($hListViewSimple1, 0, "Logiciels inactifs", 200, 2)
	_GUICtrlListView_InsertColumn ($hListViewSimple1, 1, "Depuis", 50, 2)
	_GUICtrlListView_InsertColumn ($hListViewSimple2, 0, "Logiciels actifs", 200, 2)
	_GUICtrlListView_InsertColumn ($hListViewSimple2, 1, "Depuis", 50, 2)
	_GUICtrlListView_InsertColumn ($hListViewDetaille, 0, "Logiciels inactifs", 200, 2)
	_GUICtrlListView_InsertColumn ($hListViewDetaille, 1, "logiciel3", 80, 2)
	_GUICtrlListView_InsertColumn ($hListViewDetaille, 2, "Logiciel1", 80, 2)
	_GUICtrlListView_InsertColumn ($hListViewDetaille, 3, "logiciel2", 80, 2)

	; Impose une taille minimum  la fentre principale.
	GUIRegisterMsg ($WM_GETMINMAXINFO, "Taille_Minimum")

	; Tableaux des lments graphiques.
	Global $TabItemListViewSimple1 [$tabLogicielsInactifs [0] [0] + 1]
	Global $TabItemListViewSimple2 [$tabLogicielActifs [0] [0] + 1]
	Global $TabItemListViewDetaille [$tabLogicielsInactifs [0] [0] + 1]

	; La premire valeur contient le nombre de listes.
	$TabItemListViewSimple1 [0] = $tabLogicielsInactifs [0] [0]
	$TabItemListViewSimple2 [0] = $tabLogicielActifs [0] [0]
	$TabItemListViewDetaille [0] = $tabLogicielsInactifs [0] [0]

	; On cre les lments contenants les listes et on les ajoute au tableau.
	For $i = 1 To $tabLogicielsInactifs [0] [0]
		$TabItemListViewSimple1 [$i] = GUICtrlCreateListViewItem ($tabLogicielsInactifs [$i] [0] & "|" & $tabLogicielsInactifs [$i] [1], $hListViewSimple1)
		Couleur ($TabItemListViewSimple1 [$i], Verifie_Date ($dossier & $tabLogicielsInactifs [$i] [0]& "\directory\bin\", $TabItemListViewSimple1 [$i], $tabLogicielsInactifs [$i] [0]), $i)
		$TabItemListViewDetaille [$i] = GUICtrlCreateListViewItem ($tabLogicielsInactifs [$i] [0] & "|" & $tabLogicielsInactifs [$i] [1], $hListViewDetaille)
		Couleur ($TabItemListViewDetaille [$i], Verifie_Date ($dossier & $tabLogicielsInactifs [$i] [0]& "\directory\bin\", $TabItemListViewDetaille [$i], $tabLogicielsInactifs [$i] [0], "Detaille"), $i)
	Next

	; On cre les lments contenants les listes et on les ajoute au tableau.
	For $i = 1 To $tabLogicielActifs [0] [0]
		$TabItemListViewSimple2 [$i] = GUICtrlCreateListViewItem ($tabLogicielActifs [$i] [0] & "|" & $tabLogicielActifs [$i] [1], $hListViewSimple2)
		Couleur ($TabItemListViewSimple2 [$i], Verifie_Date ($dossier & $tabLogicielActifs [$i] [0] & "\directory\bin\", $TabItemListViewSimple2 [$i], $tabLogicielActifs [$i] [0]), $i)
	Next

	Ajuste_Affichage ($tItemLimit)

	Global $menuAffichage = GUICtrlCreateMenu ("Affichage")
	Global $modeAffichage = GuiCtrlCreateMenuItem ("Dtaill", $menuAffichage, 0)
	GUICtrlSetOnEvent ($modeAffichage, "Mode")
	Global $actualiserAffichage = GuiCtrlCreateMenuItem ("Actualiser", $menuAffichage, 1)
	GUICtrlSetOnEvent ($actualiserAffichage, "Actualiser")

	Global $menuExport = GUICtrlCreateMenu ("Export")
	Global $actifExport = GuiCtrlCreateMenuItem ("Actifs", $menuExport, 0)
	GUICtrlSetOnEvent ($actifExport, "Export_Actif")
	Global $inactifExport = GuiCtrlCreateMenuItem ("Inactifs", $menuExport, 1)
	GUICtrlSetOnEvent ($inactifExport, "Export_Inactif")

	Global $menuInfos = GUICtrlCreateMenu ("?")
	Global $aProposDeInfos = GuiCtrlCreateMenuItem (" propos de", $menuInfos, 0)
	GUICtrlSetOnEvent ($aProposDeInfos, "A_Propos_De")
	Global $codeCouleurInfos = GuiCtrlCreateMenuItem ("Code couleur", $menuInfos, 1)
	GUICtrlSetOnEvent ($codeCouleurInfos, "Code_Couleur")
	Global $aInfosAffichageSimple = GuiCtrlCreateMenuItem ("Infos affichage simple", $menuInfos, 2)
	GUICtrlSetOnEvent ($aInfosAffichageSimple, "Infos_Affichage_Simple")
	Global $aInfosAffichageDetaille = GuiCtrlCreateMenuItem ("Infos affichage dtaill", $menuInfos, 3)
	GUICtrlSetOnEvent ($aInfosAffichageDetaille, "Infos_Affichage_Detaille")

	; Affiche la fentre.
	GUISetState (@SW_SHOW, $fenetrePrincipale)

	Return 1
EndFunc
#EndRegion ### Fin : Affiche_Tableau #########

#Region ### Ajuste_Affichage #########
; Ajuste l'affichage de la fentre principale.
Func Ajuste_Affichage ($pItemLimit)
	Local $tabPos = WinGetPos ($fenetrePrincipale)

	; Ajuste la hauteur de la fentre.
	$iHeight = Hauteur ($pItemLimit)

	If ($tabPos [1] + $iHeight) > @DesktopHeight Then $tabPos [1] = (@DesktopHeight - $iHeight) / 2

	; On repositionne et redimensionne la fentre.
	WinMove ($fenetrePrincipale, "", $tabPos [0], $tabPos [1], $iWidth, $iHeight)
EndFunc
#EndRegion ### Fin : Ajuste_Affichage #########

#Region ### Analyse_Dossier #########
; Tous les rpertoires se trouvant dans le dossier indiqu en paramtre, qui ne commencent pas par un "@" et qui possde les exe recherchs, sont stocks dans un tableau.
Func Analyse_Dossier ($pDossier, $vLogiciel = "")
	; On s'assure que le chemin du dossier se tremine par un antislash, sinon on l'ajoute.
	If Not (StringRight ($pDossier, 1) = "\") Then $pDossier &= "\"
	; On rcupre le handle du premier fichier.
	$handle = FileFindFirstFile ($pDossier & "*")
	; Si on obtient "-1", il y a eu une erreur.
	If Not ($handle = -1) Then
		While True
			; On rcupre le premier fichier.
			$logicielDir = FileFindNextFile ($handle)
			; On quitte la boucle s'il n'y a plus de fichier.
			If @error Then ExitLoop
			; On vrifie qu'il s'agit bien d'un dossier.
			If @extended Then
				; On ignore les dossiers qui commencent par un @.
				If Not (StringLeft ($logicielDir, 1) = "@") Then
					; On vrifie que le dossier contient au moins l'un des trois excutables (logiciel3, Logiciel1, logiciel2).
					If FileExists ($pDossier & $logicielDir & "\directory\bin\logiciel3.exe") Or FileExists ($pDossier & $logicielDir & "\directory\bin\logiciel1.exe") Or FileExists ($dossier & $logicielDir & "\directory\bin\logiciel2.exe") Then
						; On ajoute les dossiers dans le tableau des logiciels en supprimant le rpertoire de recherche.
						; Si $vLogiciel est vide, on ajoute le dossier courant.
						If $vLogiciel = "" Then
							_ArrayAdd ($tabLogiciel, StringReplace ($logicielDir, $pDossier, ""))
						Else
							_ArrayAdd ($tabLogiciel, StringReplace ($vLogiciel & "\" & $logicielDir, $pDossier, ""))
						EndIf
						; On incrmente le nombre de logiciels contenus.
						$tabLogiciel [0] += 1
					Else
						; Si $vLogiciel est vide, on ajoute le dossier courant en paramtre.
						If $vLogiciel = "" Then
							Analyse_Dossier ($pDossier & $logicielDir, $logicielDir)
						Else
							Analyse_Dossier ($pDossier & $logicielDir, $vLogiciel & "\" & $logicielDir)
						EndIf
					EndIf
				EndIf
			EndIf
		WEnd
	EndIf
EndFunc
#EndRegion ### Fin : Analyse_Dossier #########

#Region ### Analyse_Generale #########
; Fonction qui appelle successivement la fonction d'analyse pour les diffrents processus.
Func Analyse_Generale ($pBoolInitialisation = False)
	; On rinitialise le tableau des chemins.
	Redim $tabChemin [1] [2]
	$tabChemin [0] [0] = 0
	Analyse_Processus ("logiciel3.exe")
	Analyse_Processus ("logiciel2.exe")
	Analyse_Processus ("logiciel1.exe")
	Supprime_Actifs ($dossier)
EndFunc
#EndRegion ### Fin : Analyse_Generale #########

#Region ### Analyse_Processus #########
; Fonction qui analyse les processus correspondant au paramtre.
Func Analyse_Processus ($pProcessus)
	; On rcupre la listes des processus que l'on souhaite analyser.
	Global $listeProcessus = ProcessList ($pProcessus)
	; On initialise le chemin prcdent, pour viter d'entrer 2 chemins identiques conscutifs (petite optimisation).
	$cheminPrecedent = ""
	; On initialise le nom du prcdent propritaire afin de savoir s'il s'agissait ou non du systme.
	$proprietairePrecedent = ""
	; On parcourt la liste des processus.
	For $i = 1 To $listeProcessus [0] [0]
		; On rcupre toutes les informations du processus.
		$process = _ProcessOpen ($listeProcessus [$i] [1], $PROCESS_QUERY_LIMITED_INFO + 0x10 + 0x00020000)
		; On rcupre le chemin du processus.
		$chemin = _ProcessGetPathname ($process)
		; On rcupre le nom du propritaire.
		$proprietaire = _ProcessGetOwner ($process)
		; Si le chemin est diffrent du chemin prcedent
		; ou s'il est identique mais que le propritaire prcdent tait le systme et que le propritaire actuel n'est pas le systme,
		; alors on l'analyse, sinon on ne fait rien.
		If ($chemin <> $cheminPrecedent) Or ((($proprietairePrecedent = "Systme") Or ($proprietairePrecedent = "SYSTEM")) And ($proprietaire <> "Systme") And ($proprietaire <> "SYSTEM")) Then
			; Le chemin actuel devient le chemin prcdent.
			$cheminPrecedent = $chemin
			; Le propritaire actuel devient le propritaire prcdent.
			$proprietairePrecedent = $proprietaire
			; On vrifie s'il y a dj des chemins prsent dans le tableau de chemin.
			If $tabChemin [0] [0] > 0 Then
				; On vrifie que le chemin n'existe pas dj pour viter les doublons.
				$indexTabChemin = _ArraySearch ($tabChemin, $chemin, 1)
				; Si le chemin n'existe pas.
				If @error = 6 Then
					; S'il s'agit d'un processus systme, on l'indique dans le tableau.
					If ($proprietaire = "Systme") Or ($proprietaire = "SYSTEM") Then
						; On l'ajoute dans le tableau de chemins en prcisant qu'il s'agit d'un processus systme.
						_ArrayAdd2D ($tabChemin, $chemin, "Systme")
					Else ; S'il ne s'agit pas d'un processus systme.
						; On l'ajoute dans le tableau de chemin sans prciser le propritaire.
						_ArrayAdd2D ($tabChemin, $chemin, "")
					EndIf
					; On incrmente le nombre de chemin contenus.
					$tabChemin [0] [0] += 1
				; Si le chemin existe (l'index doit tre suprieur  0).
				ElseIf ($indexTabChemin > 0) Then
					; Si le propritaire mmoris est le systme et que le propritaire actuel n'est pas le systme, alors on supprime le propritaire enregistr.
					If ($tabChemin [$indexTabChemin] [1] = "Systme") And (Not (($proprietaire = "Systme") Or ($proprietaire = "SYSTEM"))) Then $tabChemin [$indexTabChemin] [1] = ""
				EndIf
			; Si le tableau de chemins est vide.
			Else
				; On ajoute le chemin dans le tableau de chemins et on incrmente le nombre de chemins contenus.
				; S'il s'agit d'un processus sytme, on l'indique dans le tableau.
					If ($proprietaire = "Systme") Or ($proprietaire = "SYSTEM") Then
						; On l'ajoute dans le tableau de chemin en prcisant qu'il s'agit d'un processus systme.
						_ArrayAdd2D ($tabChemin, $chemin, "Systme")
					Else ; S'il ne s'agit pas d'un processus systme.
						; On l'ajoute dans le tableau de chemin sans prciser le propritaire.
						_ArrayAdd2D ($tabChemin, $chemin, "")
					EndIf
				$tabChemin [0] [0] += 1
			EndIf
		EndIf
	Next
EndFunc
#EndRegion ### Fin : Analyse_Processus #########

#Region ### A_Propos_De #########
; Information sur le logiciel.
Func A_Propos_De ()
	MsgBox (0, " propos de ""Logiciel Inactifs.exe""", "Version " & $numVersion & @CRLF & "Application dveloppe par Jrmy Deligny" & @CRLF & @CRLF & "Permet de visualiser, en temps rel, les logiciels recherchs qui ne sont pas en cours d'utilisation ou utiliss seulement par le systme.")
EndFunc
#EndRegion ### Fin : A_Propos_De #########

#Region ### Code_Couleur #########
; Fentre d'information sur les codes couleurs utiliss dans le logiciel.
Func Code_Couleur ()
	MsgBox (64, "Code couleur", "Noir => Le logiciel  moins de 8 moins (Logiciel1, logiciel2) ou moins de 4 mois (logiciel3)." & @CRLF & @CRLF & _
								"Orange => Le logiciel  entre 8 et 12 mois (Logiciel1, logiciel2) ou entre 4 et 6 mois (logiciel3)." & @CRLF & @CRLF & _
								"Rouge => Le logiciel  plus de 12 mois (Logiciel1, logiciel2) ou plus de 6 mois (logiciel3)." & @CRLF & @CRLF & @CRLF & _
								"Fond gris => Seul le compte systme utilise le processus. Vrifier les services.")
EndFunc
#EndRegion ### Fin : Code_Couleur #########

#Region ### Compare_Date #########
; Compare une date passe en paramtre avec la date du jour.
; Deux types de comparaisons :
; Type 1 => Expiration au bout d'un an, critique aprs 8 mois (logiciel2, Logiciel1).
; Type 2 => Expiration au bout de 6 mois, critique aprs 4 mois (logiciel3).
Func Compare_Date ($pDate, $pAJour, $pTypeCompare = 1)
	Local $tAJour = $pAJour
	If $pTypeCompare = 2 Then
		; Si la date est l'anne en cours.
		If ($pDate [0] = @YEAR) Then
			; Si l'on ajoute 6 mois et que la date est infrieur  la date courante, le logiciel doit tre mis  jour.
			If (($pDate [1] + 6) < @MON) Or ((($pDate [1] + 6) = @MON) And (@MDAY > $pDate [2])) Then
				$tAJour = 3
			; Si l'on ajoute 4 mois et que la date est infrieur  la date courante, le logiciel entre en priode critique.
			ElseIf (($pDate [1] + 4) < @MON) Or ((($pDate [1] + 4) = @MON) And (@MDAY > $pDate [2])) Then
				$tAJour = 2
			EndIf
		Else ; Si la date n'est pas l'anne en cours.
			; Si l'anne est infrieure  l'anne dernire, ou que 6 mois se sont couls depuis le dbut de l'anne ou que le logiciel  plus de 6 mois.
			If ($pDate [0] < (@YEAR - 1)) Or (@MON > 6) Or (((12 - $pDate [1]) + @MON) > 6) Or (((12 - $pDate [1] - @MON) = 6) And (@MDAY > $pDate [2])) Then
				; Le logiciel doit tre mis  jour.
				$tAJour = 3
			; Si 4 mois se sont couls, ou si
			ElseIf (@MON > 4) Or (((12 - $pDate [1]) + @MON) > 4) Or (((12 - $pDate [1] - @MON) = 4) And (@MDAY > $pDate [2])) Then
				; Le logiciel entre en priode critique.
				$tAJour = 2
			EndIf
		EndIf
	Else
		; Si la date est l'anne en cours.
		If ($pDate [0] = @YEAR) Then
			; Si l'on ajoute 8 mois et que la date est infrieur  la date courante, le logiciel entre en priode critique.
			If (($pDate [1] + 8) < @MON) Or ((($pDate [1] + 8) = @MON) And (@MDAY > $pDate [2])) Then $tAJour = 2
		Else ; Si la date n'est pas l'anne en cours.
			; Si l'anne est infrieure  l'anne dernire, ou que le mois est infrieure au mois en cours ou que le mois est gale au mois en cours mais le jour est infrier a jour en cours.
			If ($pDate [0] < (@YEAR - 1)) Or (($pDate [1] < @MON)) Or (($pDate [1] = @MON) And (@MDAY > $pDate [2])) Then
				; Le logiciel doit tre mis  jour.
				$tAJour = 3
			ElseIf (@MON > 8) Or (((12 - $pDate [1]) + @MON) > 8) Or (((12 - $pDate [1] - @MON) = 8) And (@MDAY > $pDate [2])) Then
				; Le logiciel entre en priode critique.
				$tAJour = 2
			EndIf
		EndIf
	EndIf
	Return $tAJour
EndFunc
#EndRegion ### Fin : Compare_Date #########

#Region ### Compare_Resultat #########
; Compare 2 tableaux pour savoir s'il y a eu des modifications.
; Enregistre les changements qui ont eu lieu.
; Remplace le tableau des rsultats.
; Retourne un boolen qui indique s'il y a eu des changements.
Func Compare_Resultat (ByRef $pTabNouveauTableau, ByRef $pTabAncienTableau, $pOption = True)
	Local $changement = False
	; Si les deux tableaux ne comporte pas le mme nombre d'entres, ils sont diffrents.
	If $pTabAncienTableau [0] [0] <> $pTabNouveauTableau [0] [0] Then
		$changement = True
		Recherche_Element (1, $pTabNouveauTableau, $pTabAncienTableau)
	Else
		; Index courrant du tableau.
		$i = 0
		; Boolen qui indique si on est  la fin du tableau.
		$fin = ($i = $pTabNouveauTableau [0] [0])
		; Tant que l'on a pas atteint la fin du tableau.
		While Not $fin
			; On passe  l'index suivant.
			$i += 1
			; On cherche si cet lment apparat dans l'autre tableau.
			$identique = ($pTabAncienTableau [$i] [0] = $pTabNouveauTableau [$i] [0])
			If Not $identique Then
				$changement = True
				ExitLoop
			EndIf
			; On vrifie si l'on a atteint la fin du tableau.
			$fin = ($i = $pTabNouveauTableau [0] [0])
		WEnd
		; S'il y a eu un changement.
		If $changement Then
			; On parcourt le reste du tableau.
			Recherche_Element ($i, $pTabNouveauTableau, $pTabAncienTableau)
		EndIf
	EndIf
	; S'il n'y a pas eu de changement dans les tableaux.
	If Not $changement Then
		; On remplace le nouveau tableau de logiciels par l'ancien pour conserver les heures.
		$pTabNouveauTableau = $pTabAncienTableau
		If $pOption Then
			If UBound ($tabAncienProcessSystem) <> UBound ($tabProcessSystem) Then
				$changement = True
			Else
				$i = 0
				While ((Not $changement) And ($i < UBound ($tabAncienProcessSystem)))
					$changement = $tabAncienProcessSystem [$i] <> $tabProcessSystem [$i]
					$i += 1
				WEnd
			EndIf
			If $changement Then $arretService = True
		EndIf
	EndIf
	Return $changement
EndFunc
#EndRegion ### Fin : Compare_Resultat #########

#Region ### Couleur #########
; Choisi la couleur pour l'lment en paramtre.
; $pElement = lment graphique
; $pStatut = tat de l'excutable
; $pIndex = Position de l'lment
Func Couleur ($pElement, $pStatut, $pIndex)
	If _ArraySearch ($tabProcessSystem, $pIndex) >= 0 Then
		GUICtrlSetBkColor ($pElement, 0xAAAAAA)
	Else
		GUICtrlSetBkColor ($pElement, 0xFFFFFF)
	EndIf

	If $pStatut = 2 Then
		GUICtrlSetColor ($pElement, 0xFF7700)
	ElseIf $pStatut = 3 Then
		GUICtrlSetColor ($pElement, 0xFF0000)
	Else
		GUICtrlSetColor ($pElement, 0x000000)
	EndIf
EndFunc
#EndRegion ### Fin : Couleur #########

#Region ### Export_Actif #########
; Exporte la liste des logiciels actifs et inactifs dans un fichier texte.
Func Export_Actif ()
	$handleExportFile = FileOpen ("Actifs.txt", 9)
	FileWriteLine ($handleExportFile, "Liste des logiciels actifs le " & @MDAY & "/" & @MON & "/" & @YEAR & "  " & @HOUR & "H" & @MIN & " :")
	For $i = 1 To $tabLogicielActifs [0] [0]
		FileWriteLine ($handleExportFile, $tabLogicielActifs [$i] [0])
	Next
	FileWriteLine ($handleExportFile, "")
	FileClose ($handleExportFile)
EndFunc
#EndRegion ### Fin : Export_Actif #########

#Region ### Export_Inactif #########
; Exporte la liste des logiciels actifs et inactifs dans un fichier texte.
Func Export_Inactif ()
	$handleExportFile = FileOpen ("Inactifs.txt", 9)
	FileWriteLine ($handleExportFile, "Liste des logiciels inactifs le " & @MDAY & "/" & @MON & "/" & @YEAR & "  " & @HOUR & "H" & @MIN & " :")
	For $i = 1 To $tabLogicielsInactifs [0] [0]
		FileWriteLine ($handleExportFile,  $tabLogicielsInactifs [$i] [0])
	Next
	FileWriteLine ($handleExportFile, "")
	FileClose ($handleExportFile)
EndFunc
#EndRegion ### Fin : Export_Inactif #########

#Region ### Hauteur #########
; Ajuste la hauteur de la fentre principale.
Func Hauteur ($pItemLimit)
	; La valeur des composant par dfaut est de 87. Chaque item  une taille de 19 pixel.
	$tmpHeight = 87 + $pItemLimit * 19
	; la hauteur doit tre au maximum, plus petite de 40 pixel que la hauteur du bureau.
	If $tmpHeight > (@DesktopHeight - 40) Then $tmpHeight = @DesktopHeight - 40
	Return $tmpHeight
EndFunc
#EndRegion ### Fin : Hauteur #########

#Region ### Infos_Affichage_Detaille #########
; Informations sur le mode d'affichage dtaill.
Func Infos_Affichage_Detaille ()
	MsgBox (64, "Affichage dtaill", "Ce mode permet d'afficher uniquement les logiciels inactifs et leur logiciel correspondant." & @CRLF & _
				"La date de chaque logiciel utilis par le logiciel est indiqu, ainsi on peut voir quels sont les logiciels qui ont le plus besoin d'une mise  jour.")
EndFunc
#EndRegion ### Fin : Infos_Affichage_Detaille #########

#Region ### Infos_Affichage_Simple #########
;Informations sur le mode d'affichage simple.
Func Infos_Affichage_Simple ()
	MsgBox (64, "Affichage simple", "Ce mode permet d'afficher simultanment les logiciels inactifs et actifs." & @CRLF & @CRLF & _
				"La colonne ""Depuis"" indique l'heure  laquelle le logiciel  acquis son statut actuel." & @CRLF & _
				"Par dfaut, il s'agit de l'heure d'ouverture du programme ""Logiciels Inactifs"".")
EndFunc
#EndRegion ### Fin : Infos_Affichage_Simple #########

#Region ### MAJ_Affichage #########
; Mise  jour de l'affichage de la fentre principale.
Func MAJ_Affichage ()
	; S'il y a moins d'lments  afficher que prcdemment pour les logiciels inactifs.
	If $tabLogicielsInactifs [0] [0] < $TabItemListViewSimple1 [0] Then
		; On supprime les lments graphiques inutiles. Valable aussi pour le mode dtaill.
		For $i = ($tabLogicielsInactifs [0] [0] + 1) To $TabItemListViewSimple1 [0]
			GUICtrlDelete ($TabItemListViewSimple1 [$i])
			GUICtrlDelete ($TabItemListViewDetaille [$i])
		Next
		; On redimensionne le tableau.
		ReDim $TabItemListViewSimple1 [$tabLogicielsInactifs [0] [0] + 1]
		ReDim $TabItemListViewDetaille [$tabLogicielsInactifs [0] [0] + 1]
	; S'il y a plus d'lments  afficher que prcdemment.
	ElseIf $tabLogicielsInactifs [0] [0] > $TabItemListViewSimple1 [0] Then
		; On redimensionne le tableau.
		ReDim $TabItemListViewSimple1 [$tabLogicielsInactifs [0] [0] + 1]
		ReDim $TabItemListViewDetaille [$tabLogicielsInactifs [0] [0] + 1]

		; On ajoute les lments graphiques manquant.
		For $i = ($TabItemListViewSimple1 [0] + 1) To $tabLogicielsInactifs [0] [0]
			$TabItemListViewSimple1 [$i] = GUICtrlCreateListViewItem ("", $hListViewSimple1)
			$TabItemListViewDetaille[$i] = GUICtrlCreateListViewItem ("", $hListViewDetaille)
		Next
	EndIf

	; S'il y a moins d'lments  afficher que prcdemment pour les logiciels actifs.
	If $tabLogicielActifs [0] [0] < $TabItemListViewSimple2 [0] Then
		; On supprime les lments graphiques inutiles. Valable aussi pour le mode dtaill.
		For $i = ($tabLogicielActifs [0] [0] + 1) To $TabItemListViewSimple2 [0]
			GUICtrlDelete ($TabItemListViewSimple2 [$i])
		Next
		; On redimensionne le tableau.
		ReDim $TabItemListViewSimple2 [$tabLogicielActifs [0] [0] + 1]
	; S'il y a plus d'lments  afficher que prcdemment.
	ElseIf $tabLogicielActifs [0] [0] > $TabItemListViewSimple2 [0] Then
		; On redimensionne le tableau.
		ReDim $TabItemListViewSimple2 [$tabLogicielActifs [0] [0] + 1]

		; On ajoute les lments graphiques manquant.
		For $i = ($TabItemListViewSimple2 [0] + 1) To $tabLogicielActifs [0] [0]
			$TabItemListViewSimple2 [$i] = GUICtrlCreateListViewItem ("", $hListViewSimple2)
		Next
	EndIf

	; On actualise l'affichage des lments graphiques des logiciels inactifs.
	For $i = 1 To $tabLogicielsInactifs [0] [0]
		GUICtrlSetData ($TabItemListViewSimple1 [$i], $tabLogicielsInactifs [$i] [0] & "|" & $tabLogicielsInactifs [$i] [1])
		Couleur ($TabItemListViewSimple1 [$i], Verifie_Date ($dossier & $tabLogicielsInactifs [$i] [0] & "\directory\bin\", $TabItemListViewSimple1 [$i], $tabLogicielsInactifs [$i] [0]), $i)
		GUICtrlSetData ($TabItemListViewDetaille [$i], $tabLogicielsInactifs [$i] [0])
		Couleur ($TabItemListViewDetaille [$i], Verifie_Date ($dossier & $tabLogicielsInactifs [$i] [0] & "\directory\bin\", $TabItemListViewDetaille [$i], $tabLogicielsInactifs [$i] [0], "Detaille"), $i)
	Next

	; On actualise l'affichage des lments graphiques des logiciels actifs.
	For $i = 1 To $tabLogicielActifs [0] [0]
		GUICtrlSetData ($TabItemListViewSimple2 [$i], $tabLogicielActifs [$i] [0] & "|" & $tabLogicielActifs [$i] [1])
		Couleur ($TabItemListViewSimple2 [$i], Verifie_Date ($dossier & $tabLogicielActifs [$i] [0] & "\directory\bin\", $TabItemListViewSimple2 [$i], $tabLogicielActifs [$i] [0]), $i)
	Next

	; Le nombre d'lments graphiques est gale au nombre d'lments  afficher.
	$TabItemListViewSimple1 [0] = $tabLogicielsInactifs [0] [0]
	$TabItemListViewSimple2 [0] = $tabLogicielActifs [0] [0]
	$TabItemListViewDetaille [0] = $tabLogicielsInactifs [0] [0]
EndFunc
#EndRegion ### Fin : MAJ_Affichage #########

#Region ### Mode #########
; Choix du mode d'affichage.
Func Mode ()
	; Si l'on est en mod dtaill, on passe en mode simple.
	If $modeDetaille Then
		$modeDetaille = False
		GUICtrlSetData ($modeAffichage, "Dtaill")
		GUICtrlSetState ($hListViewDetaille, $GUI_HIDE)
		GUICtrlSetState ($hListViewSimple1, $GUI_SHOW)
		GUICtrlSetState ($hListViewSimple2, $GUI_SHOW)
		For $i = 1 To $TabItemListViewSimple1 [0]
			Verifie_Date ($dossier & $tabLogicielsInactifs [$i] [0] & "\directory\bin\", $TabItemListViewSimple1 [$i], $tabLogicielsInactifs [$i] [0])
		Next
		For $i = 1 To $TabItemListViewSimple2 [0]
			Verifie_Date ($dossier & $tabLogicielActifs [$i] [0] & "\directory\bin\", $TabItemListViewSimple2 [$i], $tabLogicielActifs [$i] [0])
		Next
		$iWidth = $widthSimple
		Local $tItemLimit = $tabLogicielsInactifs [0] [0]
		If $tabLogicielActifs [0] [0] > $tabLogicielsInactifs [0] [0] Then $tItemLimit = $tabLogicielActifs [0] [0]
		Ajuste_Affichage ($tItemLimit)
	Else ; Si l'on est en mode simple, on passe en mode dtaill.
		$modeDetaille = True
		GUICtrlSetData ($modeAffichage, "Simple")
		GUICtrlSetState ($hListViewSimple1, $GUI_HIDE)
		GUICtrlSetState ($hListViewSimple2, $GUI_HIDE)
		GUICtrlSetState ($hListViewDetaille, $GUI_SHOW)
		For $i = 1 To $TabItemListViewDetaille [0]
			Verifie_Date ($dossier & $tabLogicielsInactifs [$i] [0] & "\directory\bin\", $TabItemListViewDetaille [$i], $tabLogicielsInactifs [$i] [0], "Detaille")
		Next
		$iWidth = $widthDetaille
		Ajuste_Affichage ($TabItemListViewDetaille [0])
	EndIf
EndFunc
#EndRegion ### Fin : Mode #########

#Region ### Quitter #########
; Fonction d'arrt du logiciel.
Func Quitter ()
	Exit
EndFunc
#EndRegion ### Fin :Quitter #########

#Region ### Recherche_Element #########
; Recherche un lment dans le tableau  partir d'un index prdtermin.
Func Recherche_Element ($pDepart, ByRef $pTabNouveauTableau, ByRef $pTabAncienTableau)
	Local $heure = @HOUR & "H" & @MIN & ":" & @SEC
	Local $tabTempAncienTableau = $pTabAncienTableau
	; On parcourt la liste des nouveaux lments  afficher.
	For $j = $pDepart To $pTabNouveauTableau [0] [0]
		$fin = False
		$k = $pDepart
		$trouve = False
		While True
			If $tabTempAncienTableau [0] [0] >= $pDepart Then
				; On cherche si cet lment apparat dans l'autre tableau.
				If $tabTempAncienTableau [$k] [0] = $pTabNouveauTableau [$j] [0] Then
					$pTabNouveauTableau [$j] [1] = $tabTempAncienTableau [$k] [1]
					$tabTempAncienTableau [0] [0] -= 1
					_ArrayDelete ($tabTempAncienTableau, $k)
					ExitLoop
				EndIf
			EndIf
			; Si l'on ne trouve pas la valeur dans l'ancien tableau et que l'on atteint la fin du tableau, c'est que le processus a chang de statut.
			If $k >= $tabTempAncienTableau [0] [0] Then
				$pTabNouveauTableau [$j] [1] = $heure
				ExitLoop
			EndIf
			$k += 1
		WEnd
	Next
;~ 	; Si le tableau d'ancien affichage n'est pas vide c'est que les processus restants sont devenus inactifs.
;~ 	For $i = $pDepart To $tabTempAncienTableau [0] [0]
;~ 		Cette partie n'est pas utilise pour le moment.
;~ 	Next
EndFunc
#EndRegion ### Fin : Recherche_Element #########

#Region ### Reduire #########
; Fonction appele lorsque l'utilisateur rduit la fentre principale.
Func Reduire ()
	Actualiser ()
EndFunc
#EndRegion ### Fin : Reduire #########

#Region ### Restaurer #########
; Fonction appele lorsque l'utilisateur restaure la fentre principale.
Func Restaurer ()
	Actualiser ()
	WinActivate ($fenetrePrincipale)
EndFunc
#EndRegion ### Fin : Restaurer #########

#Region ### Supprime_Actifs #########
; Fonction qui supprime les logiciels actifs et qui retourne un tableau contenant les logiciels inactifs.
Func Supprime_Actifs ($pDossier)
	Local $heure = @HOUR & "H" & @MIN & ":" & @SEC
	; On vrifie que le nom du dossier se termine bien par "\", sinon on l'ajoute.
	If Not (StringRight ($pDossier, 1) = "\") Then $pDossier &= "\"
	Local $tabTempLogicielsInactifs [UBound ($tabLogiciel)] [2]
	$tabTempLogicielsInactifs [0] [0] = $tabLogiciel [0]
	Local $tabTempLogicielsActifs [1] [2]
	$tabTempLogicielsActifs [0] [0] = 0
	; On mmorise l'ancien tableau des processus Systme.
	$tabAncienProcessSystem = $tabProcessSystem
	; On initialise le tableau contenant les index des processus systme.
	Redim $tabProcessSystem [1]
	$tabProcessSystem [0] = ""
	; On va supprimer des entres dans le tableau, cette variable va permettre de savoir o l'on se trouve dans le tableau, mme aprs modification.
	$h = 1

	; On parcourt tout le tableau temporaire.
	For $i = 1 To $tabTempLogicielsInactifs [0] [0]
		$tabTempLogicielsInactifs [$h] [0] = $tabLogiciel [$i]
		$tabTempLogicielsInactifs [$h] [1] = $heure
		; On parcourt tout le tableau des logiciels.
		For $j = 1 To $tabChemin [0] [0]
			; On vrifie si la chane du tableau temporaire existe dans le tableau des chemins.
			If StringInStr ($tabChemin [$j] [0], $pDossier & $tabTempLogicielsInactifs [$h] [0] & "\directory\bin\") Then
				; S'il s'agit d'un processus systme.
				If $tabChemin [$j] [1] = "Systme" Then
					; Si le premier lment est vide.
					If $tabProcessSystem [0] = "" Then
						; On place l'index du logiciel inactif en cours dans le premier lment.
						$tabProcessSystem [0] = $h
					Else
						; On ajoute un lment dans lequel on place l'index du logiciel inactif en cours.
						_ArrayAdd ($tabProcessSystem, $h)
					EndIf
				; S'il ne s'agit pas d'un processus systme.
				Else
					; On ajoute le logiciel  la liste des actifs.
					$tabTempLogicielsActifs [0] [0] += 1
					ReDim $tabTempLogicielsActifs [$tabTempLogicielsActifs [0] [0] + 1] [2]
					$tabTempLogicielsActifs [$tabTempLogicielsActifs [0] [0]] [0] = $tabTempLogicielsInactifs [$h] [0]
					$tabTempLogicielsActifs [$tabTempLogicielsActifs [0] [0]] [1] = $heure

					; On efface l'entre correspondante dans le tableau temporaire.
					_ArrayDelete ($tabTempLogicielsInactifs, $h)
					; On dcrmente le nombre de logiciels.
					$tabTempLogicielsInactifs [0] [0] -= 1
					; On vient d'enlever une entre, donc l'entre suivante portera le mme index que l'index actuel.
					; On dcrmente la variable qui sera ensuite incrmente pour revenir au mme index.
					$h -= 1
					; On supprime l'entre du tableau de chemin pour ne plus avoir  l'analyser.
					_ArrayDelete ($tabChemin, $j)
					; On dcrmente le nombre de chemin.
					$tabChemin [0] [0] -= 1
					ExitLoop
				EndIf
			EndIf
		Next
		; On incrmente l'index actuel.
		$h += 1
	Next
	; On affecte les valeurs aux tableaux dfinitifs.
	$tabLogicielsInactifs = $tabTempLogicielsInactifs
	$tabLogicielActifs = $tabTempLogicielsActifs
EndFunc
#EndRegion ### Fin : Supprime_Actifs #########

#Region ### Taille_Minimum #########
; Impose une taille minimum  la fentre, aussi bien en largeur qu'en hauteur.
Func Taille_Minimum ($pWnd, $pMsg, $pParam1, $pParam2)
    Local $minmaxinfo = DllStructCreate ("int;int;int;int;int;int;int;int;int;int", $pParam2)
    ; Largeur minimum.
	DllStructSetData ($minmaxinfo, 7, $iWidth)
	; Hauteur minimum : quivaut  deux items de liste.
    DllStructSetData ($minmaxinfo, 8, 125)
EndFunc
#EndRegion ### Fin : Taille_Minimum #########

#Region ### Verifie_Date #########
#cs #########################################################################################################
Vrifie la date des excutables du dossier.
Paramtre :
	$pDossier =
Retourne 1 si le logiciel  moins de 4 mois pour logiciel3 ou moins de 8 mois pour Logiciel1 et logiciel2.
Retourne 2 si le logiciel  plus de 4 mois et mois de 6 mois pour logiciel3 ou plus de 8 mois et moins de 12 mois pour Logiciel1 et logiciel2.
Retourne 3 si le logiciel  plus de 6 mois pour logiciel3 et plus de 12 mois pour Logiciel1 et logiciel2.
#ce #########################################################################################################
Func Verifie_Date ($pDossier, ByRef $pItem, $pLogiciel, $pTypeItem = "Simple")
	$tAJour = 1
	; Initiliasation des variables contenant les dates des exe.
	Local $tDate1 = ""
	Local $tDate2 = ""
	Local $tDate3 = ""
	Local $tDate [6] = ["", "", "", "", "", ""]
	; Si logiciel1.exe existe.
	If FileExists ($pDossier & "logiciel1.exe") Then
		; On rcupre la date de modification.
		$tDate = FileGetTime ($pDossier & "logiciel1.exe", 0, 0)
		$tDate1 = $tDate [2] & "/" & $tDate [1] & "/" & $tDate [0]
		; On compare les dates.
		$tAJour = Compare_Date ($tDate, $tAJour, 1)
	EndIf
	; Si logiciel2.exe existe et que l'on n'a pas dtect qu'une mise  jour est obligatoire.
	If FileExists ($pDossier & "logiciel2.exe") Then
		; On rcupre la date de modification.
		$tDate = FileGetTime ($pDossier & "logiciel2.exe", 0, 0)
		$tDate2 = $tDate [2] & "/" & $tDate [1] & "/" & $tDate [0]
		If ($tAJour < 3) Then
			; On compare les dates.
			$tAJour = Compare_Date ($tDate, $tAJour, 1)
		EndIf
	EndIf
	; Si logiciel3.exe existe et que l'on n'a pas dtect qu'une mise  jour est obligatoire.
	If FileExists ($pDossier & "logiciel3.exe") Then
		; On rcupre la date de modification.
		$tDate = FileGetTime ($pDossier & "logiciel3.exe", 0, 0)
		$tDate3 = $tDate [2] & "/" & $tDate [1] & "/" & $tDate [0]
		If ($tAJour < 3) Then
			; On compare les dates.
			$tAJour = Compare_Date ($tDate, $tAJour, 2)
		EndIf
	EndIf

	; S'il s'agit de l'item d'taill, on met  jour chaque partie de l'item.
	If $pTypeItem = "Detaille" Then
		GUICtrlSetData ($pItem, "|" & $tDate3)
		GUICtrlSetData ($pItem, "||" & $tDate1)
		GUICtrlSetData ($pItem, "|||" & $tDate2)
	EndIf
	Return $tAJour
EndFunc
#EndRegion ### Fin : Verifie_Date #########

#Region ### Verifie_Processus #########
; Fonction qui permet la comparaison des processus actuels avec les anciens processus puis actualise l'affichage.
Func Verifie_Processus ()
	While True
		Analyse_Generale ()
		; Le code n'analyse pas toutes les parties d'un "If Or", il faut donc forcer l'excution de la seconde partie.
		local $boolCompareActif = Compare_Resultat ($tabLogicielActifs, $tabAncienLogiclielsActifs, False)
		If Compare_Resultat ($tabLogicielsInactifs, $tabAncienLogicielsInactifs) Or $boolCompareActif Then
			MAJ_Affichage ()
			Local $tItemLimit = $tabLogicielsInactifs [0] [0]
			If $tabLogicielActifs [0] [0] > $tabLogicielsInactifs [0] [0] Then $tItemLimit = $tabLogicielActifs [0] [0]
			Ajuste_Affichage ($tItemLimit)
			If $arretService Then
				$arretService = False
			EndIf
		EndIf
		$tabAncienLogicielsInactifs = $tabLogicielsInactifs
		$tabAncienLogiclielsActifs = $tabLogicielActifs
		Sleep (200)
	WEnd
EndFunc
#EndRegion ### Fin : Verifie_Processus #########